blob: 9d8b55d0bd9cf21d89495c01b056dd69cfb48cdc [file] [log] [blame]
cgeoffroy549e20f2017-03-03 16:10:40 +01001#!/bin/bash
2export DOCKER_HOST="unix:///var/run/docker.sock"
3
4set -e
5set -x
6
7W() {
cgeoffroy349dc0b2017-03-15 16:24:58 +01008 # Wait until a line appears in the screen session.
9 # It starts from the beginning of the log and exits after the first match.
10 local T=${2:-20s}
11 #timeout -k 3s ${T} stdbuf -o0 grep -q -m 1 "^${1}" <(tail -F -n+0 screenlog.0)
12 # (HACK) As Jenkins blocks subshell, we must use an intermediate script
13 local SUBF=$(mktemp)
14 chmod +x ${SUBF}
15 cat > ${SUBF} <<- EOF
16 #!/bin/bash -e
17 while true; do
18 if strings screenlog.0 | grep -m 1 "\${1}"; then
19 exit 0
20 fi
21 sleep 0.5s
22 done
23 EOF
cgeoffroy0412c622017-04-11 10:58:53 +020024 local RES=0
25 timeout -k 3s ${T} ${SUBF} "${1}" || RES=$?
cgeoffroy349dc0b2017-03-15 16:24:58 +010026 rm -f ${SUBF}
cgeoffroy0412c622017-04-11 10:58:53 +020027 if [ ! "$RES" = "0" ]; then
28 sync
cgeoffroy5ca7aae2017-04-11 11:20:23 +020029 echo -e "\n\n\n(Debug) Error while waiting for a pattern to appear in screenlog.0\n\n\n"
cgeoffroy0412c622017-04-11 10:58:53 +020030 strings screenlog.0
31 fi
cgeoffroy349dc0b2017-03-15 16:24:58 +010032 return ${RES}
cgeoffroy549e20f2017-03-03 16:10:40 +010033}
34
35Cmd() {
36 # Send a command to the screen session, aka into the containernet prompt
37 screen -S sonemu -X stuff "${1}^M"
38}
39
40
41if ! screen --version | grep 'Screen version'; then
42 # Install screen and do an initial cleanup
43 sudo apt-get update -qq -y
44 sudo apt-get install -y screen
45 screen --version | grep 'Screen version'
46fi
cgeoffroyae307a92017-03-17 10:48:26 +010047if ! timeout --version; then
48 # Install coreutils for the timeout command
49 sudo apt-get update -qq -y
50 sudo apt-get install -y coreutils
51 timeout --version
52fi
cgeoffroy549e20f2017-03-03 16:10:40 +010053# Initial cleanup
cgeoffroye2a48492017-04-12 10:48:34 +020054pkill --signal KILL -f 'SCREEN -L -S sonemu' || true
55sleep 1s
cgeoffroy549e20f2017-03-03 16:10:40 +010056screen -wipe || true
57rm -f screenlog.0
58
59
60# Start containernet with a topology
cgeoffroy4b9ba682017-03-17 12:51:18 +010061screen -L -S sonemu -d -m sudo python src/emuvim/examples/simple_topology.py
cgeoffroy549e20f2017-03-03 16:10:40 +010062# Setup screen for immediate flusing
63screen -S sonemu -X logfile flush 0
64# Wait for the cli to start
cgeoffroy736c4aa2017-03-17 11:48:15 +010065W '^*** Starting CLI:' 60s
cgeoffroy549e20f2017-03-03 16:10:40 +010066# Print nodes
67Cmd 'nodes'
68# Start vnf1
69son-emu-cli compute start -d datacenter1 -n vnf1 && sleep 1s
70# Start vnf2
71son-emu-cli compute start -d datacenter1 -n vnf2 && sleep 1s
72# List compute nodes
73son-emu-cli compute list && sleep 1s
cgeoffroy6f86be72017-03-17 13:26:50 +010074sync # avoid text overlapping
cgeoffroy1d6978b2017-04-11 11:05:56 +020075# Gather some infos
cgeoffroy75591cd2017-04-11 11:21:27 +020076Cmd 'sh sync'
77Cmd 'sh echo "... starting various checks"'
cgeoffroy1d6978b2017-04-11 11:05:56 +020078sync # avoid text overlapping
cgeoffroy014a10a2017-04-11 17:16:49 +020079Cmd 'vnf1 ifconfig && echo -e "\\n... checked vnf1"'
cgeoffroy349dc0b2017-03-15 16:24:58 +010080W "^... checked vnf1"
cgeoffroy014a10a2017-04-11 17:16:49 +020081Cmd 'vnf2 ifconfig && echo -e "\\n... checked vnf2"'
cgeoffroy349dc0b2017-03-15 16:24:58 +010082W "^... checked vnf2"
cgeoffroy549e20f2017-03-03 16:10:40 +010083# Try to ping vnfs
cgeoffroy014a10a2017-04-11 17:16:49 +020084Cmd 'vnf1 ping -c 2 vnf2 && echo -e "\\n... checked ping"'
cgeoffroy349dc0b2017-03-15 16:24:58 +010085W "^... checked ping" 20s
cgeoffroy549e20f2017-03-03 16:10:40 +010086Cmd 'quit'
87# Wait for sonemu to end
cgeoffroy1d6978b2017-04-11 11:05:56 +020088W '*** Done'
cgeoffroy549e20f2017-03-03 16:10:40 +010089
cgeoffroy349dc0b2017-03-15 16:24:58 +010090echo -e '\n\n******************* Result ******************\n\n'
cgeoffroy549e20f2017-03-03 16:10:40 +010091strings screenlog.0
92echo -e '\n\n*********************************************\n\n'
93
94
95# Check the ping result
96if grep ', 2 received' screenlog.0; then
97 echo 'No problems detected'
98 exit 0
99else
100 echo 'Ping is broken !'
101 exit 1
102fi